#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_PopupCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_PopupCFG> M_PopupCFG::msSingleton(nullptr);

int M_PopupCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_PopupCFGData* M_PopupCFG::GetData(std::string Key)
{
	auto it = mMapData.find(Key);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<std::string, M_PopupCFGData>& M_PopupCFG::GetMapData()
{
	return mMapData;
}

void M_PopupCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_PopupCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_PopupCFGData data;
		data.mKey = element->Attribute("Key");
		data.mScene = element->Attribute("Scene");
		data.mRewardCon = element->IntAttribute("RewardCon");
		data.mOtherDes = element->Attribute("OtherDes");
		data.mOder = element->IntAttribute("Oder");
		{
			const char* Channel = element->Attribute("Channel");
			std::vector<std::string> vecChannel;
			boost::split(vecChannel, Channel, boost::is_any_of(","));
			for (unsigned int i = 0; i < vecChannel.size(); i++)
			{
				data.mChannel.push_back(vecChannel[i]);
			}
		}
		if (mMapData.find(data.mKey) != mMapData.end())std::cout <<"data refind:" << data.mKey << std::endl;
		assert(mMapData.find(data.mKey) == mMapData.end());
		mMapData.insert(std::make_pair(data.mKey, data));
		element = element->NextSiblingElement();
	}
}

void M_PopupCFG::Load()
{
	Load("../Config/M_PopupCFG.xml");
}

M_PopupCFG* M_PopupCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_PopupCFG());
	}
	return msSingleton.get();
}
